public static class EMCCVStylegroup {  
  public String title = "default";
  public Map<String, EMCCVStyle> styles = new LinkedHashMap<String, EMCCVStyle>();

  public EMCCVStylegroup(String title) {
    this.title = title;
  }

  public void resetStyles() {
    for (Map.Entry<String, EMCCVStyle> entry : styles.entrySet()) {
      entry.getValue().selected = false;
    }
  }


  public boolean randomize() { 
    resetStyles();
    boolean success = false;
    int index = 0;

    int repeat = 0;

    while (!success) {
      index = 0; // the index of the style in this stylegroup
      int r = random.nextInt(styles.size());

      for (Map.Entry<String, EMCCVStyle> entry : styles.entrySet()) {
        if (r == index && checkParents(entry.getValue().parent)) {
          entry.getValue().selected = true;
          success = true;
          if (logging && repeat > 3) {
            log.append(getTime() + "[RANDMONIZATION PARENT WARNING] ATTEMPT #" + repeat + "; stylegroup '" + this.title + "' for '" + entry.getValue().xmlParent + "'\n");
          }
          break;
        } else {
          // this style can not be selected. Try the next one.
          index++;
          if (index == styles.size()) {
            resetStyles();
            repeat++;
            if (repeat > 10) {
              if (logging) log.append(getTime() + "[RANDMONIZATION PARENT ERROR]   Given up after 10 attempts: stylegroup '" + this.title + "' for '" + entry.getValue().xmlParent + "'\n");
              if (logging) log.append(getTime() + "|||||||||||||||||||||||||||||   Restarting randomization process for ASPECT '" + entry.getValue().xmlParent + "'\n");
              return success;
            }
          }
        }
      }
    }
    return success;
  }
}